#ifndef NEUTRONDETECTORCONSTRUCTIONMESSENGER_HH
#define NEUTRONDETECTORCONSTRUCTIONMESSENGER_HH

#include "G4UImessenger.hh"

class NeutronDetectorConstruction;

class G4UIdirectory;
class G4UIcmdWithABool;
class G4UIcmdWithAString;
class G4UIcmdWithAnInteger;
class G4UIcmdWithADoubleAndUnit;
class G4UIcmdWithoutParameter;

class NeutronDetectorConstructionMessenger : public G4UImessenger
{
public:
  NeutronDetectorConstructionMessenger(NeutronDetectorConstruction*);
  virtual ~NeutronDetectorConstructionMessenger();

  void SetNewValue(G4UIcommand*, G4String);

protected:
  NeutronDetectorConstruction* fNeutronDetectorConstruction;

  G4UIdirectory* fNeutronDetectorDirectory;

  G4UIcmdWithoutParameter* fUpdateCmd;

  G4UIcmdWithAnInteger* fNeutNumberCmd;
  G4UIcmdWithADoubleAndUnit* fNeutSizeXCmd;
  G4UIcmdWithADoubleAndUnit* fNeutSizeYCmd;
  G4UIcmdWithADoubleAndUnit* fNeutSizeZCmd;
  G4UIcmdWithADoubleAndUnit* fNeutGapCmd;
  G4UIcmdWithAnInteger* fNeutRotationModeCmd;

  G4UIcmdWithAnInteger* fVetoNumberCmd;
  G4UIcmdWithADoubleAndUnit* fVetoSizeXCmd;
  G4UIcmdWithADoubleAndUnit* fVetoSizeYCmd;
  G4UIcmdWithADoubleAndUnit* fVetoSizeZCmd;
  G4UIcmdWithADoubleAndUnit* fVetoGapYCmd;
  G4UIcmdWithADoubleAndUnit* fVetoGapZCmd;
  G4UIcmdWithAnInteger* fVetoRotationModeCmd;

  G4UIcmdWithAnInteger* fNeutLayerNumberCmd;
  G4UIcmdWithADoubleAndUnit* fNeutLayerGapCmd;

  G4UIcmdWithADoubleAndUnit* fNeutVetoGapCmd;

  G4UIcmdWithAnInteger* fStuckNumberCmd;
  G4UIcmdWithADoubleAndUnit* fStuckGapCmd;
  G4UIcmdWithADoubleAndUnit* fStuckIntervalCmd;

  G4UIcmdWithADoubleAndUnit* fPositionXCmd;
  G4UIcmdWithADoubleAndUnit* fPositionYCmd;
  G4UIcmdWithADoubleAndUnit* fPositionZCmd;
};

#endif

