#ifndef DALI2CONSTRUCTION_HH
#define DALI2CONSTRUCTION_HH

#include "G4VUserDetectorConstruction.hh"
#include "G4ThreeVector.hh"

class G4LogicalVolume;
class G4VSensitiveDetector;
class G4Material;

class DetectorConstruction;

class DALI2Construction : public G4VUserDetectorConstruction
{
  friend class DetectorConstruction;
  
public:
  DALI2Construction();
  virtual ~DALI2Construction();

  G4VPhysicalVolume* Construct();
  virtual G4LogicalVolume* ConstructSub();

  G4ThreeVector GetDALI2Size(){return fDALI2Size;}

protected:
  G4ThreeVector fDALI2Size;

  G4LogicalVolume* fLogicDALI2;
  G4LogicalVolume* fLogicWorld;

  G4VSensitiveDetector* fScintillatorSD;

  G4Material* fDALI2Material;
  G4Material* fDALI2Material_Al;
  G4Material* fDALI2Material_MgO;
  G4Material* fDALI2Material_NaI;
  G4Material* fWorldMaterial;

  G4String fDALI2GeometryIn, fDALI2GeometryOut;
};

#endif

