#ifndef DETECTORCONSTRUCTIONEXAMPLEDALI2_HH
#define DETECTORCONSTRUCTIONEXAMPLEDALI2_HH

#include "G4VUserDetectorConstruction.hh"

class G4LogicalVolume;
class G4Material;
class DetectorConstructionExampleDALI2Messenger;
class SourceConstruction;
class BeamPipeConstruction;
class DALI2Construction;

class DetectorConstructionExampleDALI2 : public G4VUserDetectorConstruction
{
public:
  DetectorConstructionExampleDALI2();
  virtual ~DetectorConstructionExampleDALI2();

  G4VPhysicalVolume* Construct();

  void UpdateGeometry();

protected:
  DetectorConstructionExampleDALI2Messenger* fDetectorConstructionExampleDALI2Messenger;

  SourceConstruction* fSourceConstruction;
  BeamPipeConstruction* fBeamPipeConstruction;
  DALI2Construction* fDALI2Construction;

  G4LogicalVolume* fLogicWorld;
  G4LogicalVolume* fLogicSource;
  G4LogicalVolume* fLogicBeamPipe;
  G4LogicalVolume* fLogicDALI2;

  G4Material* fWorldMaterial;
  G4Material* fAirMaterial;
};

#endif

