#ifndef DETECTORCONSTRUCTIONEXAMPLENEBULA_HH
#define DETECTORCONSTRUCTIONEXAMPLENEBULA_HH

#include "G4VUserDetectorConstruction.hh"

class G4LogicalVolume;
class G4Material;
class DetectorConstruction;
class DetectorConstructionExampleNEBULAMessenger;
class TargetConstruction;
class NeutronWindowConstruction;
class DipoleConstruction;
class NeutronDetectorConstruction;

class DetectorConstructionExampleNEBULA : public G4VUserDetectorConstruction
{
public:
  DetectorConstructionExampleNEBULA();
  virtual ~DetectorConstructionExampleNEBULA();

  G4VPhysicalVolume* Construct();

  void UpdateGeometry();

protected:
  DetectorConstructionExampleNEBULAMessenger* fDetectorConstructionExampleNEBULAMessenger;

  TargetConstruction* fTargetConstruction;
  NeutronWindowConstruction* fNeutronWindowConstruction;
  DipoleConstruction* fDipoleConstruction;
  NeutronDetectorConstruction* fNeutronDetectorConstruction;

  G4LogicalVolume* fLogicWorld;
  G4LogicalVolume* fLogicTarget;
  G4LogicalVolume* fLogicNeutronWindow;
  G4LogicalVolume* fLogicDipole;
  G4LogicalVolume* fLogicNEBULA;
  G4LogicalVolume* fLogicAir;

  G4Material* fWorldMaterial;
  G4Material* fAirMaterial;
};

#endif

