
#include "DetectorConstructionExampleDALI2Messenger.hh"
#include "DetectorConstructionExampleDALI2.hh"

#include "G4UIdirectory.hh"
#include "G4UIcmdWithoutParameter.hh"

DetectorConstructionExampleDALI2Messenger::DetectorConstructionExampleDALI2Messenger(DetectorConstructionExampleDALI2* Det)
 : fDetectorConstructionExampleDALI2(Det)
{
  fDetectorDirectory = new G4UIdirectory("/detector/");
  fDetectorDirectory->SetGuidance("Modification Commands for Detector");

  fUpdateCmd = new G4UIcmdWithoutParameter("/detector/update",this);
  fUpdateCmd->SetGuidance("Update geometry.");
  fUpdateCmd->SetGuidance("This command MUST be applied before \"beamOn\" ");
  fUpdateCmd->SetGuidance("if you changed geometrical value(s)");
  fUpdateCmd->AvailableForStates(G4State_PreInit,G4State_Idle);
}

DetectorConstructionExampleDALI2Messenger::~DetectorConstructionExampleDALI2Messenger()
{
  delete fDetectorDirectory;
  delete fUpdateCmd;
}

void DetectorConstructionExampleDALI2Messenger::SetNewValue(G4UIcommand* command, G4String /* newValue */)
{
  if(command == fUpdateCmd){
    fDetectorConstructionExampleDALI2->UpdateGeometry();
  }
}


