
#include "DetectorConstructionExampleNEBULAMessenger.hh"
#include "DetectorConstructionExampleNEBULA.hh"

#include "G4UIdirectory.hh"
#include "G4UIcmdWithoutParameter.hh"

DetectorConstructionExampleNEBULAMessenger::DetectorConstructionExampleNEBULAMessenger(DetectorConstructionExampleNEBULA* Det)
 : fDetectorConstructionExampleNEBULA(Det)
{
  fDetectorDirectory = new G4UIdirectory("/detector/");
  fDetectorDirectory->SetGuidance("Modification Commands for Detector");

  fUpdateCmd = new G4UIcmdWithoutParameter("/detector/update",this);
  fUpdateCmd->SetGuidance("Update geometry.");
  fUpdateCmd->SetGuidance("This command MUST be applied before \"beamOn\" ");
  fUpdateCmd->SetGuidance("if you changed geometrical value(s)");
  fUpdateCmd->AvailableForStates(G4State_PreInit,G4State_Idle);
}

DetectorConstructionExampleNEBULAMessenger::~DetectorConstructionExampleNEBULAMessenger()
{
  delete fDetectorDirectory;
  delete fUpdateCmd;
}

void DetectorConstructionExampleNEBULAMessenger::SetNewValue(G4UIcommand* command, G4String /* newValue */)
{
  if(command == fUpdateCmd){
    fDetectorConstructionExampleNEBULA->UpdateGeometry();
  }
}


