
#include "TSimulationDataScintillator.hh"

#include <iostream>
#include <algorithm>
#include <iterator>

ClassImp(TSimulationDataScintillator)

TSimulationDataScintillatorArray* gSimulationDataScintillatorArray = 0;

std::ostream& operator<<(std::ostream& out, const TSimulationDataScintillator& simulationDataScintillator)
{
  out << simulationDataScintillator.fSensitiveDetectorName << " ";
  out << simulationDataScintillator.fModuleName << " ";
  std::vector<Int_t> id = simulationDataScintillator.fModuleID;
  std::copy(id.begin(), id.end(), std::ostream_iterator<Int_t>(out, " "));
  out << simulationDataScintillator.fPrimaryParticleID << " ";
  out << simulationDataScintillator.fPDGCode << " ";
  out << simulationDataScintillator.fParticleName << " ";
  out << simulationDataScintillator.fProcessName << " ";
  out << simulationDataScintillator.fPrePosition.X() << " ";
  out << simulationDataScintillator.fPrePosition.Y() << " ";
  out << simulationDataScintillator.fPrePosition.Z() << " ";
  out << simulationDataScintillator.fPostPosition.X() << " ";
  out << simulationDataScintillator.fPostPosition.Y() << " ";
  out << simulationDataScintillator.fPostPosition.Z() << " ";
  out << simulationDataScintillator.fPreMomentum.X() << " ";
  out << simulationDataScintillator.fPreMomentum.Y() << " ";
  out << simulationDataScintillator.fPreMomentum.Z() << " ";
  out << simulationDataScintillator.fPostMomentum.X() << " ";
  out << simulationDataScintillator.fPostMomentum.Y() << " ";
  out << simulationDataScintillator.fPostMomentum.Z() << " ";
  out << simulationDataScintillator.fPreKineticEnergy << " ";
  out << simulationDataScintillator.fPostKineticEnergy << " ";
  out << simulationDataScintillator.fPreTime << " ";
  out << simulationDataScintillator.fPostTime << " ";
  out << simulationDataScintillator.fEnergyDeposit;
  if(!simulationDataScintillator.fUserDouble.empty()){
    for(int i=0; i<(int)simulationDataScintillator.fUserDouble.size(); ++i) out << " " << simulationDataScintillator.fUserDouble[i];
  }
  if(!simulationDataScintillator.fUserInt.empty()){
    for(int i=0; i<(int)simulationDataScintillator.fUserInt.size(); ++i) out << " " << simulationDataScintillator.fUserInt[i];
  }

  return out;
}

TSimulationDataScintillator::TSimulationDataScintillator() : TObject()
{;}

TSimulationDataScintillator::~TSimulationDataScintillator()
{;}
